/* EX22_0
 Problema: Escrever um programa em C que faa reserva de passagens aereas de
 uma companhia. Alem da leitura do numero dos voos e da quantidade de lugares
 disponiveis, ler varios pedidos de reserva, constituidos do numero da carteira
 de identidade e do nome do cliente, do numero do voo desejado. Para cada
 cliente, verificar se ha disponibilidade no voo desejado. Em caso afirmativo
 imprimir o numero da carteira de identidade e do nome do cliente, o numero do
 voo , atualizando o numero de lugares disponiveis. Caso contrario, avisar ao
 cliente da inexistencia de lugares. O programa deve mostrar uma mensagem do
 tipo <Enter>- para digitar pedidos, e <Esc>-para finalizar. Considere fixo e
 igual a 30 o numero de voos da companhia.

Resolucao: O programa deve ter os seguintes passos:
  1 - definir os tipos de dados; (declarar as variaveis)
  2 - permitir que voce digite o numero efetivo de voos (valor de "n");
  3 - repeticao para:
       3.1 - ler os numeros dos voos existentes, um de cada vez;
       3.2 - ler a quantidade de lugares disponiveis nos voos;
      
  4 - repeticao para atender os clientes:
       4.1 - ler o numero da identidade do cliente;
       4.2 - ler o nome de um cliente;
       4.3 - ler o numero do voo desejado;
       4.4 - verificar a existencia do voo?
              4.4.1 - guardar o indice da posicao do voo;
              4.4.2 - ou mostrar a mensagem: voo inexistente;
       4.5 - verificar disponibilidade de lugares no voo?
              4.5.1 - emitir o bilhete;
              4.5.2 - atualizar numero de lugares disponiveis;
              4.5.3 - ou mostrar a mensagem: voo lotado;
       4.6 - mostrar a mensagem: Deseja atender outro cliente ? 
                                 Tecle <Enter> - para Sim, ou 
                                         <Esc> - para No.

descricao das variaveis
  n - numero efetivo de voos - numero de repeticoes
  i - contador de repeticao (indice - controlador da repeticao)
  vetVoo - vetor com os numeros dos voos existentes
  vetListDisp - vetor com a quantidade de lugares disponiveis nos voos
  identClient - numero da identidade do cliente
  nomeClient - nome de um cliente
  numVoo - numero do voo desejado
  apont - indice da posicao do voo desejado
  atende - tecla, para controle repetio de atendimento ao cliente

*/

#include <stdio.h>  /* arquivo de inclusao para entrada e saida, para usar: scanf e printf */
#include <conio.h>  /* para usar: getch e clrscr*/
#include <string.h> /* para usar: strcpy*/

#define NMAXVOOS 30 /* numero maximo de voo  */
#define TNOMES 20     /* tamanho maximo dos nomes dos clientes */

int main ()
{
  int n; /* numero efetivo de voos na execucao do programa - numero de repeticoes*/
  int i; /* contador de repeticao */
  int vetVoo[NMAXVOOS]; /* vetor com os numeros dos voos existentes */
  int vetListDisp[NMAXVOOS]; /* vetor com a quantidade de lugares disponiveis nos voos */
  int identClient; /* numero da identidade de um cliente */
  char nomeClient[TNOMES]; /* nome de um cliente */
  int numVoo; /* numero do voo desejado */  
  int apont; /* indice da posicao do voo desejado */ 
  char atende;

  //clrscr(); // limpa a janela do usuario

  //define valores iniciais
  printf("\nDigite o numero efetivo de voos (n): ");
  scanf("%d", &n);

  for(i=0; i<n; i++)//for1
  {
	printf("\nDados dos voos %d:",i+1);
	printf("\n\tNumero: ");
	scanf("%d",&vetVoo[i]);
	printf("\tLugares Disponiveis : ");
	scanf("%d", &vetListDisp[i]);
  }//for1
  
  //Atender clientes	
  do{//inicio - do-while
    //clrscr(); // limpa a janela do usuario
	printf ("\n\nDados do pedido do cliente:");
	printf("\n\tNumero da identidade : ");
	scanf("%d", &identClient);
	printf("\tNome: ");
	//flushall();
	//fflush(stdin);
    getchar();
	gets(nomeClient);
	printf("\tNumero do voo: ");
	scanf("%d",&numVoo);
	//verificar a existencia do voo
	i=0;
	while ((i<n) && (numVoo != vetVoo[i]))
	{
	  i = i + 1;
	}
	if(vetVoo[i] == numVoo)
	{
	  apont = i;	
	}
	else
    {
      printf("\nVoo %d: inexistente", numVoo);
      apont = -1;
    }
    //verificar disponibilidade de lugares no voo
    if(apont != -1)
    {  
      if(vetListDisp[apont] >0)
      {
        printf("\n\n\tEmissao do bilhete:");
        printf("\n\tNumero da identidade : %d", identClient);
        printf("\n\tNome: %s", nomeClient);
        printf("\n\tNumero do voo: %d", numVoo);
        vetListDisp[apont] = vetListDisp[apont] - 1;	
      }
      else
      {
        printf("\n\tVoo de numero: %d estah lotado", numVoo);
      }
    } 
	printf ("\n\nDeseja atender outro cliente ?");
	printf ("\nTeclar <enter> - para Sim, ou");
    printf ("\n         <esc> - para Nao");
    atende = getch(); //leitura da tecla teclada, sem teclar o <enter>
  }while (atende == 13); //fim - do-while 

  return 0;
}
